
#define C_JPROB         5

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#pragma hdrstop

#include "..\..\rpme\src\engine.hpp"
#include "..\..\rpme\src\engine.cpp"
#include "..\..\rpme\src\mutate.cpp"

#include "random.cpp"
#include "disasm.cpp"
#include "testcode.cpp"

BYTE* mem = NULL;
DWORD mem_count = 0;

BYTE* __cdecl my_malloc(DWORD fp,DWORD len)
{
  if (!mem) mem = (BYTE*)malloc(65536*2);
  BYTE *t = &mem[mem_count];
  mem_count += len;
  return t;
}

void main()
{
  id1();                        // register
  id2();
  id3();
  id4();


  BYTE ibuf[4096];
  BYTE obuf[4096];

/////////////////////////////////////////////////////////////////////////////
  mem_count = 0;
  memset(ibuf,0xCC,sizeof(ibuf));
  printf("#0 executing engine...\n");
  int res =
  engine(0x12345678,
         (BYTE*)&permut_lo_offs,
         (DWORD)&permut_hi_offs-(DWORD)&permut_lo_offs,
         (DWORD)&permut_main-(DWORD)&permut_lo_offs,
         ibuf,
         sizeof(ibuf),
         NULL,         //&oentry,
         -1,            // filler
         0,             // extrelfix
         C_JPROB,             // jmpprob
         my_rnd,
         mutate,
         disasm,
         my_malloc
        );
  printf("#0 engine result = %i\n", res);
  if (res!=ERR_SUCCESS) exit(0);
  printf("#0 executing permutated code...\n");
  typedef void voidproc();
  voidproc *x = (voidproc*)((DWORD)ibuf);
  x();
  printf("#0 success!\n");
  printf("#0  %i bytes of memory used\n", mem_count);

  /////////////////////////////////////////////////////////////////////////////

  for (int pass=0; ; pass++)
  {
    printf("pass#%i\n",pass);
//  if  (pass==36) exit(0);

  /////////////////////////////////////////////////////////////////////////////
    mem_count = 0;
    memset(obuf,0xCC,sizeof(obuf));
    printf("#1 executing engine...\n");
    res =
    engine(0x12345678,
           &ibuf[0],
           sizeof(ibuf),
           0,
           obuf,
           sizeof(obuf),
           NULL,         //&ientry,
           -1,            // filler
           0,             // extrelfix
           C_JPROB,             // jmpprob
           my_rnd,
           mutate,
           disasm,
           my_malloc
          );
    printf("#1 engine result = %i\n", res);
    if (res!=ERR_SUCCESS) exit(0);
    printf("#1 executing permutated code...\n");
    x = (voidproc*)((DWORD)obuf);
    x();
    printf("#1 success!\n");
    printf("#1  %i bytes of memory used\n", mem_count);

  /////////////////////////////////////////////////////////////////////////////
    mem_count = 0;
    memset(ibuf,0xCC,sizeof(ibuf));
    printf("#2 executing engine...\n");
    res =
    engine(0x12345678,
           &obuf[0],
           sizeof(obuf),
           0,
           ibuf,
           sizeof(ibuf),
           NULL,         //&oentry,
           -1,            // filler
           0,             // extrelfix
           C_JPROB,             // jmpprob
           my_rnd,
           mutate,
           disasm,
           my_malloc
          );
    printf("#2 engine result = %i\n", res);
    if (res!=ERR_SUCCESS) exit(0);
    printf("#2 executing permutated code...\n");
    x = (voidproc*)((DWORD)ibuf);
    x();
    printf("#2 success!\n");
    printf("#2  %i bytes of memory used\n", mem_count);


  /////////////////////////////////////////////////////////////////////////////
  }
  /////////////////////////////////////////////////////////////////////////////

} // main

